package com.jasamedika.medifirst2000.controller;

import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.dto.BowidickDto;
import com.jasamedika.medifirst2000.service.BowidickService;
import com.jasamedika.medifirst2000.vo.BowidickVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Collections;
import java.util.List;
import java.util.Map;

import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.springframework.http.HttpStatus.INTERNAL_SERVER_ERROR;
import static org.springframework.http.HttpStatus.OK;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

@RestController
@RequestMapping("/bowidick")
public class BowidickController extends LocaleController<BowidickVO> {

	@Autowired
	private BowidickService bowidickService;

	@RequestMapping(value = "/save-bowidick", method = POST, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<List<Map<String, Object>>> saveBowidick(@RequestBody BowidickDto dto,
			HttpServletRequest request) {
		Map<String, Object> result = this.bowidickService.saveBowidick(dto);
		if (!result.isEmpty()) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(Collections.singletonList(result), OK, mapHeaderMessage);
		}
		return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
	}

	@RequestMapping(value = "/get-bowidick", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> getBowidick(@RequestParam(value = "startDate") String startDate,
			@RequestParam(value = "endDate") String endDate, HttpServletRequest request) {
		Map<String, Object> result = this.bowidickService.getBowidick(startDate, endDate);
		if (!result.isEmpty()) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, OK, mapHeaderMessage);
		}
		return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
	}

	@RequestMapping(value = "/get-bowidick-by-norec", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> getBowidickByNoRec(@RequestParam("noRec") String noRec,
			HttpServletRequest request) {
		Map<String, Object> result = this.bowidickService.getBowidickbyNorec(noRec);
		if (!result.isEmpty()) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, OK, mapHeaderMessage);
		}
		return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
	}

}
